Var
   Playboy    : Array[0..3] of Pointer;
   PlayPal    : Pointer;
   Data       : File;

Procedure Border (Color : Byte);Assembler;
ASM
           mov ah,10h
           mov al,1
           mov bh,Color
           int 10h
End;

Function Escape:Boolean;
Begin
    Escape:=False;
    If Port[$60]=1 then Escape:=True;
End;


Procedure WaitVbl;Assembler;
Asm
           mov   dx,3dah
@1:        in    al,dx

           test  al,8
           jnz   @1
@2:        in    al,dx
           test  al,8
           jz    @2
End;

Procedure VideoMode(Mode:Byte);Assembler;
Asm
           mov   ah,0
           mov   al,Mode
           int   10h
End;


Procedure SetColor (Color,R,G,B:Byte);
Begin
    Port[$3c8]:=Color;
    Port[$3c9]:=R;
    Port[$3c9]:=G;
    Port[$3c9]:=B;
End;


Procedure Set320x400;Assembler;
ASM
           mov    dx,03c4h
           mov    al,04h
           out    dx,al
           inc    dx
           in     al,dx
           and    al,0c7h
           or     al,04h
           out    dx,al

           mov    dx,03c4h
           mov    al,02h
           out    dx,al
           inc    dx
           mov    al,0fh
           out    dx,al                { Leave all planes on! }

           mov    dx,03d4h
           mov    al,9
           out    dx,al
           inc    dx
           mov    al,0
           out    dx,al

           mov    ax,0a000h
           mov    es,ax
           xor    di,di
           xor    ax,ax
           mov    cx,8000h
           rep    stosw
           mov    dx,03d4h
           mov    al,14h
           out    dx,al
           inc    dx
           in     al,dx
           and    al,0bfh
           out    dx,al

           dec    dx
           mov    al,17h
           out    dx,al
           inc    dx
           in     al,dx
           or     al,40h
           out    dx,al

End;

Procedure LoadFile (Var Pnt:Pointer;FileName:String);
Var
   Data : File;
   S    : LongInt;
Begin
    Assign (Data,FileName);
    Reset (Data,1);
    S:=FileSize(Data)-1;
    GetMem (Pnt,S);
    BlockRead (Data,Pnt^,S);
    Close (Data);
End;


Procedure SetPalette;
Var
   S, T : Word;
Begin
     For T:=0 to 63 do
       Begin
           SetColor (T,Mem[Seg(PlayPal^):T*3],0,0);
           SetColor (T+64,0,Mem[Seg(PlayPal^):T*3+1],0);
           SetColor (T+128,0,0,Mem[Seg(PlayPal^):T*3+1]);
       End;
{     SetColor (0,0,0,0);
     SetColor (64,0,63,0);
     SetColor (128,0,0,63);}
End;

Procedure InitPlayBoy;
Var
   T   : Byte;
   X,Y : Word;
   P   : Pointer;
Begin
     VideoMode ($13);
     Border (255);
     Set320x400;
     SetPalette;

     For T:=0 to 3 do
         Begin
             Port[$3c4]:=2;
             Port[$3c5]:=1 shl T;
             P:=PlayBoy[T];
             ASM
                push    ds
                push    es
                push    di
                push    si
                mov     ax,0a000h
                mov     es,ax
                xor     di,di
                lds     si,P
                mov     cx,133
@CopyP:
                push    cx
                mov     cx,80
@MakeLine:
                mov     al,[si]
                and     al,3fh
                mov     es:[di],al
                add     al,64
                mov     es:[di+80],al
                add     al,64
                mov     es:[di+160],al
                add     di,1
                add     si,1
                dec     cx
                jnz     @MakeLine
                pop     cx
                add     di,160
                dec     cx
                jnz     @CopyP

                pop     si
                pop     di
                pop     es
                pop     ds
             End;
         End;
End;


Procedure LoadFiles;
Begin
     LoadFile (PlayPal,'PICTURE.PAL');
     LoadFile (PlayBoy[0],'PLANE1.RAW');
     LoadFile (PlayBoy[1],'PLANE2.RAW');
     LoadFile (PlayBoy[2],'PLANE3.RAW');
     LoadFile (PlayBoy[3],'PLANE4.RAW');
End;

Begin
     LoadFiles;
     InitPlayBoy;
     Repeat
     Until Escape;
     VideoMode (3);
     Writeln;
     Writeln ('Fake True Color...coded by Scout/SuccesS');
     Writeln ('esspecially for INSIGHT issue 1');
     Writeln;
     Writeln ('Picture is copyright 1995 Playboy Enterprises Inc.');
End.

